Subject: Re: [PATCH V4] powerpc/MPIC: Add get_version API both for internal and external use

From: Scott Wood <[email-masked]>
Date: Tue, 9 Apr 2013 22:20:08 -0500

On 04/09/2013 10:14:06 PM, Jia Hongtao-B38951 wrote:
>=20
>=20
> > -----Original Message-----
> > From: Wood Scott-B07421
> > Sent: Wednesday, April 10, 2013 11:12 AM
> > To: Jia Hongtao-B38951
> > Cc: Wood Scott-B07421; [email-masked];
> > [email-masked]; Li Yang-R58472
> > Subject: Re: [PATCH V4] powerpc/MPIC: Add get_version API both for
> > internal and external use
> >
> > On 04/09/2013 10:10:37 PM, Jia Hongtao-B38951 wrote:
> > >
> > >
> > > > -----Original Message-----
> > > > From: Wood Scott-B07421
> > > > Sent: Wednesday, April 10, 2013 11:08 AM
> > > > To: Jia Hongtao-B38951
> > > > Cc: Wood Scott-B07421; [email-masked];
> > > > [email-masked]; Li Yang-R58472
> > > > Subject: Re: [PATCH V4] powerpc/MPIC: Add get_version API both =20
> for
> > > > internal and external use
> > > >
> > > > On 04/09/2013 10:04:44 PM, Jia Hongtao-B38951 wrote:
> > > > > Since all the functions including mpic_alloc() and =20
> mpic_init() do
> > > the
> > > > > check for MPIC_FSL before using fsl_mpic_get_version() I'd =20
> like
> > > to add
> > > > > check just for fsl_mpic_primary_get_version().
> > > > >
> > > > > It will be like this:
> > > > > u32 fsl_mpic_primary_get_version(void)
> > > > > {
> > > > >         struct mpic *mpic =3D mpic_primary;
> > > > >
> > > > >         if (mpic && (mpic->flags & MPIC_FSL))
> > > > >                 return fsl_mpic_get_version(mpic);
> > > > >
> > > > >         return 0;
> > > > > }
> > > > >
> > > > > Could we reach an agreement here?
> > > >
> > > > Is there any particular reason?  It would be more robust and =20
> more
> > > > consistent if the check were done in fsl_mpic_get_version().
> > > >
> > > > -Scott
> > >
> > > I found out that all the functions using fsl_mpic_get_version() =20
> have
> > > already done the check. Adding the check in fsl_mpic_get_version()
> > > will cause duplicate check there. This is my consideration.
> >
> > Does that duplicate check cause any harm?
> >
> > -Scott
>=20
> No harm at all just not necessary.

Not *necessary*, but makes it more robust and more consistent.

> I wonder if I could add check in fsl_mpic_get_version() and remove =20
> all the
> check from functions in which using fsl_mpic_get_version()?

One of the two places that calls it is the place that maps thiscpuregs =20
in the first place, so no. :-)

The check in mpic_init() for the number of timers could perhaps have =20
the check removed if we're comfortable equating a version of zero with =20
a non-FSL MPIC.  This really isn't something that's worth worrying =20
about, though.

-Scott=